function dataset = genDataRandPermSparseVar(Trange, N)
% generating training data for the Schmidhuber random permutation task, 
% in the Sutskever/Martens reading, with variable lengths.
% Trange = [Tmin Tmax] is length range of a run, N is nr of datastrings 
% output dataset is a structure with N elements, each of which is a sparse
% input and target matrix


dataset = cell(1,N);
for i = 1:N
    thisT = randi([Trange(1), Trange(2)]);
    % initialize I/O data
    thisIO = zeros(thisT,200);
    % create pure distractor symbol sequence
    symbols = randi([3, 100],thisT,1);
    % decide whether 1 or 2 is first/last element
    choice = randi([1, 2]);
    symbols(1) = choice;
    
    
    % fill inputs
    for t = 1:thisT
        thisIO(t,symbols(t)) = 1;
    end
    % fill outputs
    for t = 1:thisT
        if  t == thisT
            thisIO(end,100+choice) = 1;
        else 
            thisIO(t,100+symbols(t+1)) = 1;        
        end
        
    end
    thisIO = sparse(thisIO);
    dataset{1,i} = thisIO;
end
