function dataset = genDataXORVar(Trange, N)
% generating training data for the Schmidhuber addition task,with varying
% lengths of sequences ranging from 0.25 * T to T
%
% T is length of  sequence, N is Nr of generated samples
% dataset is array of size ceil(11 * T / 10) x 3 x N, where the first column
% per page contains the addition candidates, the second the trigger bits,
% and the last in its first row the total used length of the current
% series, and in its second row the required normalized sum.

dataset = zeros(Trange(2), 3, N);
for i = 1:N
     % compute current useful length
    thisT = randi([Trange(1),Trange(2)]);
    %thisT = 200;
    % compute first add index
    T1 = ceil(rand * thisT / 10);
    T2 = ceil(rand * thisT / 2);
    while T1 >= T2
        T2 = ceil(rand * thisT / 2);
    end
    % fill first column
    dataset(1:thisT,1,i) = randi([0 1],thisT,1);
    
    % fill second column
    dataset(T1,2,i) = 1;
    dataset(T2,2,i) = 1;
    % fill third column
    dataset(1,3,i) = thisT;
    arg1 = dataset(T1,1,i); arg2 = dataset(T2,1,i);
    if arg1 == arg2
        dataset(2,3,i) = 0;
    else
        dataset(2,3,i) = 1;
    end
end