function S = allstatesNotstartstateLeakyC(W, Win, LR, input, startstate, ...
     CcueTime, ClambdaCue, ClambdaPostCue, Calpha)
% run reservoir with internal weights W and input weights Win in input,
% which is given as column sequence. Return all reservoir states except the
% starting state, as columns in a matrix. The leaking rate input LR can be
% a scalar or a column vector of unit-specific leaking rates.
L = size(input,1);
dim = size(W,1);
S = zeros(dim, L);
% initialize state
s = startstate;
% initialize conceptor
C = 1 * eye(dim);


for i = 1:L
    if  0 % i <= CcueTime + 4
        s = (1-LR) * s + LR * tanh(W * s + Win * input(i,:)');
        C = C + ClambdaCue * ((s - C * s)*s' - Calpha^(-2) * C);
    else
        s = C * ((1-LR) * s + LR * tanh(W * s + Win * input(i,:)'));
        C = C + ClambdaPostCue * ((s - C * s)*s' - Calpha^(-2) * C);
    end
    
    S(:,i) = s;
end
