function s = pickstatesLeaky(W, Win, LR, input, startstate, picks)
% run reservoir with internal weights W and input weights Win in input,
% which is given as column sequence. 
% Argument picks is an index sequence for picking some from the reservoir
% sates which arise during the run.


L = size(input,1);
dim = size(W,1);
s = zeros(dim, L);
% initialize state
x = startstate;
for i = 1:L
    x = (1-LR) * x + LR * tanh(W * x + Win * input(i,:)');
    s(:,i) = x;
end
s = s(:,picks);